//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko December,2005
//
//			to Maria Dzinleska




#include <stdio.h>
#include <string.h>
#include <math.h>

#define			HLength	54
#define			Sc	19
#define			nS	10

FILE *f1,*f2;

char	infn[256];

char	in01fn[256]="./11c_11/_1/ls.txt";
char	in02fn[256]="./11c_11/_2/ls.txt";
char	in03fn[256]="./11c_11/_3/ls.txt";
char	in04fn[256]="./11c_11/_4/ls.txt";
char	in05fn[256]="./11c_11/_5/ls.txt";
char	in06fn[256]="./11c_11/_6/ls.txt";
char	in07fn[256]="./11c_11/_7/ls.txt";
char	in08fn[256]="./11c_11/_8/ls.txt";
char	in09fn[256]="./11c_11/_9/ls.txt";
char	in10fn[256]="./11c_11/_a10/ls.txt";
char	in11fn[256]="./11c_11/_a11/ls.txt";
char	in12fn[256]="./11c_11/_a12/ls.txt";
char	in13fn[256]="./11c_11/_a13/ls.txt";
char	in14fn[256]="./11c_11/_a14/ls.txt";
char	in15fn[256]="./11c_11/_a15/ls.txt";
char	in16fn[256]="./11c_11/_a16/ls.txt";
char	in17fn[256]="./11c_11/_a17/ls.txt";
char	in18fn[256]="./11c_11/_a18/ls.txt";
char	in19fn[256]="./11c_11/_a19/ls.txt";

char	in01fn_01[256]="./11c_12/_1/ls.txt";
char	in02fn_01[256]="./11c_12/_2/ls.txt";
char	in03fn_01[256]="./11c_12/_3/ls.txt";
char	in04fn_01[256]="./11c_12/_4/ls.txt";
char	in05fn_01[256]="./11c_12/_5/ls.txt";
char	in06fn_01[256]="./11c_12/_6/ls.txt";
char	in07fn_01[256]="./11c_12/_7/ls.txt";
char	in08fn_01[256]="./11c_12/_8/ls.txt";
char	in09fn_01[256]="./11c_12/_9/ls.txt";
char	in10fn_01[256]="./11c_12/_a10/ls.txt";
char	in11fn_01[256]="./11c_12/_a11/ls.txt";
char	in12fn_01[256]="./11c_12/_a12/ls.txt";
char	in13fn_01[256]="./11c_12/_a13/ls.txt";
char	in14fn_01[256]="./11c_12/_a14/ls.txt";
char	in15fn_01[256]="./11c_12/_a15/ls.txt";
char	in16fn_01[256]="./11c_12/_a16/ls.txt";
char	in17fn_01[256]="./11c_12/_a17/ls.txt";
char	in18fn_01[256]="./11c_12/_a18/ls.txt";
char	in19fn_01[256]="./11c_12/_a19/ls.txt";

char	in01fn_02[256]="./11c_13/_1/ls.txt";
char	in02fn_02[256]="./11c_13/_2/ls.txt";
char	in03fn_02[256]="./11c_13/_3/ls.txt";
char	in04fn_02[256]="./11c_13/_4/ls.txt";
char	in05fn_02[256]="./11c_13/_5/ls.txt";
char	in06fn_02[256]="./11c_13/_6/ls.txt";
char	in07fn_02[256]="./11c_13/_7/ls.txt";
char	in08fn_02[256]="./11c_13/_8/ls.txt";
char	in09fn_02[256]="./11c_13/_9/ls.txt";
char	in10fn_02[256]="./11c_13/_a10/ls.txt";
char	in11fn_02[256]="./11c_13/_a11/ls.txt";
char	in12fn_02[256]="./11c_13/_a12/ls.txt";
char	in13fn_02[256]="./11c_13/_a13/ls.txt";
char	in14fn_02[256]="./11c_13/_a14/ls.txt";
char	in15fn_02[256]="./11c_13/_a15/ls.txt";
char	in16fn_02[256]="./11c_13/_a16/ls.txt";
char	in17fn_02[256]="./11c_13/_a17/ls.txt";
char	in18fn_02[256]="./11c_13/_a18/ls.txt";
char	in19fn_02[256]="./11c_13/_a19/ls.txt";

char	in01fn_03[256]="./11c_14/_1/ls.txt";
char	in02fn_03[256]="./11c_14/_2/ls.txt";
char	in03fn_03[256]="./11c_14/_3/ls.txt";
char	in04fn_03[256]="./11c_14/_4/ls.txt";
char	in05fn_03[256]="./11c_14/_5/ls.txt";
char	in06fn_03[256]="./11c_14/_6/ls.txt";
char	in07fn_03[256]="./11c_14/_7/ls.txt";
char	in08fn_03[256]="./11c_14/_8/ls.txt";
char	in09fn_03[256]="./11c_14/_9/ls.txt";
char	in10fn_03[256]="./11c_14/_a10/ls.txt";
char	in11fn_03[256]="./11c_14/_a11/ls.txt";
char	in12fn_03[256]="./11c_14/_a12/ls.txt";
char	in13fn_03[256]="./11c_14/_a13/ls.txt";
char	in14fn_03[256]="./11c_14/_a14/ls.txt";
char	in15fn_03[256]="./11c_14/_a15/ls.txt";
char	in16fn_03[256]="./11c_14/_a16/ls.txt";
char	in17fn_03[256]="./11c_14/_a17/ls.txt";
char	in18fn_03[256]="./11c_14/_a18/ls.txt";
char	in19fn_03[256]="./11c_14/_a19/ls.txt";

char	in01fn_04[256]="./11c_15/_1/ls.txt";
char	in02fn_04[256]="./11c_15/_2/ls.txt";
char	in03fn_04[256]="./11c_15/_3/ls.txt";
char	in04fn_04[256]="./11c_15/_4/ls.txt";
char	in05fn_04[256]="./11c_15/_5/ls.txt";
char	in06fn_04[256]="./11c_15/_6/ls.txt";
char	in07fn_04[256]="./11c_15/_7/ls.txt";
char	in08fn_04[256]="./11c_15/_8/ls.txt";
char	in09fn_04[256]="./11c_15/_9/ls.txt";
char	in10fn_04[256]="./11c_15/_a10/ls.txt";
char	in11fn_04[256]="./11c_15/_a11/ls.txt";
char	in12fn_04[256]="./11c_15/_a12/ls.txt";
char	in13fn_04[256]="./11c_15/_a13/ls.txt";
char	in14fn_04[256]="./11c_15/_a14/ls.txt";
char	in15fn_04[256]="./11c_15/_a15/ls.txt";
char	in16fn_04[256]="./11c_15/_a16/ls.txt";
char	in17fn_04[256]="./11c_15/_a17/ls.txt";
char	in18fn_04[256]="./11c_15/_a18/ls.txt";
char	in19fn_04[256]="./11c_15/_a19/ls.txt";

char	in01fn_05[256]="./11c_16/_1/ls.txt";
char	in02fn_05[256]="./11c_16/_2/ls.txt";
char	in03fn_05[256]="./11c_16/_3/ls.txt";
char	in04fn_05[256]="./11c_16/_4/ls.txt";
char	in05fn_05[256]="./11c_16/_5/ls.txt";
char	in06fn_05[256]="./11c_16/_6/ls.txt";
char	in07fn_05[256]="./11c_16/_7/ls.txt";
char	in08fn_05[256]="./11c_16/_8/ls.txt";
char	in09fn_05[256]="./11c_16/_9/ls.txt";
char	in10fn_05[256]="./11c_16/_a10/ls.txt";
char	in11fn_05[256]="./11c_16/_a11/ls.txt";
char	in12fn_05[256]="./11c_16/_a12/ls.txt";
char	in13fn_05[256]="./11c_16/_a13/ls.txt";
char	in14fn_05[256]="./11c_16/_a14/ls.txt";
char	in15fn_05[256]="./11c_16/_a15/ls.txt";
char	in16fn_05[256]="./11c_16/_a16/ls.txt";
char	in17fn_05[256]="./11c_16/_a17/ls.txt";
char	in18fn_05[256]="./11c_16/_a18/ls.txt";
char	in19fn_05[256]="./11c_16/_a19/ls.txt";

char	in01fn_06[256]="./11c_17/_1/ls.txt";
char	in02fn_06[256]="./11c_17/_2/ls.txt";
char	in03fn_06[256]="./11c_17/_3/ls.txt";
char	in04fn_06[256]="./11c_17/_4/ls.txt";
char	in05fn_06[256]="./11c_17/_5/ls.txt";
char	in06fn_06[256]="./11c_17/_6/ls.txt";
char	in07fn_06[256]="./11c_17/_7/ls.txt";
char	in08fn_06[256]="./11c_17/_8/ls.txt";
char	in09fn_06[256]="./11c_17/_9/ls.txt";
char	in10fn_06[256]="./11c_17/_a10/ls.txt";
char	in11fn_06[256]="./11c_17/_a11/ls.txt";
char	in12fn_06[256]="./11c_17/_a12/ls.txt";
char	in13fn_06[256]="./11c_17/_a13/ls.txt";
char	in14fn_06[256]="./11c_17/_a14/ls.txt";
char	in15fn_06[256]="./11c_17/_a15/ls.txt";
char	in16fn_06[256]="./11c_17/_a16/ls.txt";
char	in17fn_06[256]="./11c_17/_a17/ls.txt";
char	in18fn_06[256]="./11c_17/_a18/ls.txt";
char	in19fn_06[256]="./11c_17/_a19/ls.txt";

char	in01fn_07[256]="./11c_18/_1/ls.txt";
char	in02fn_07[256]="./11c_18/_2/ls.txt";
char	in03fn_07[256]="./11c_18/_3/ls.txt";
char	in04fn_07[256]="./11c_18/_4/ls.txt";
char	in05fn_07[256]="./11c_18/_5/ls.txt";
char	in06fn_07[256]="./11c_18/_6/ls.txt";
char	in07fn_07[256]="./11c_18/_7/ls.txt";
char	in08fn_07[256]="./11c_18/_8/ls.txt";
char	in09fn_07[256]="./11c_18/_9/ls.txt";
char	in10fn_07[256]="./11c_18/_a10/ls.txt";
char	in11fn_07[256]="./11c_18/_a11/ls.txt";
char	in12fn_07[256]="./11c_18/_a12/ls.txt";
char	in13fn_07[256]="./11c_18/_a13/ls.txt";
char	in14fn_07[256]="./11c_18/_a14/ls.txt";
char	in15fn_07[256]="./11c_18/_a15/ls.txt";
char	in16fn_07[256]="./11c_18/_a16/ls.txt";
char	in17fn_07[256]="./11c_18/_a17/ls.txt";
char	in18fn_07[256]="./11c_18/_a18/ls.txt";
char	in19fn_07[256]="./11c_18/_a19/ls.txt";

char	in01fn_08[256]="./11c_19/_1/ls.txt";
char	in02fn_08[256]="./11c_19/_2/ls.txt";
char	in03fn_08[256]="./11c_19/_3/ls.txt";
char	in04fn_08[256]="./11c_19/_4/ls.txt";
char	in05fn_08[256]="./11c_19/_5/ls.txt";
char	in06fn_08[256]="./11c_19/_6/ls.txt";
char	in07fn_08[256]="./11c_19/_7/ls.txt";
char	in08fn_08[256]="./11c_19/_8/ls.txt";
char	in09fn_08[256]="./11c_19/_9/ls.txt";
char	in10fn_08[256]="./11c_19/_a10/ls.txt";
char	in11fn_08[256]="./11c_19/_a11/ls.txt";
char	in12fn_08[256]="./11c_19/_a12/ls.txt";
char	in13fn_08[256]="./11c_19/_a13/ls.txt";
char	in14fn_08[256]="./11c_19/_a14/ls.txt";
char	in15fn_08[256]="./11c_19/_a15/ls.txt";
char	in16fn_08[256]="./11c_19/_a16/ls.txt";
char	in17fn_08[256]="./11c_19/_a17/ls.txt";
char	in18fn_08[256]="./11c_19/_a18/ls.txt";
char	in19fn_08[256]="./11c_19/_a19/ls.txt";

char	in01fn_09[256]="./11c_110/_1/ls.txt";
char	in02fn_09[256]="./11c_110/_2/ls.txt";
char	in03fn_09[256]="./11c_110/_3/ls.txt";
char	in04fn_09[256]="./11c_110/_4/ls.txt";
char	in05fn_09[256]="./11c_110/_5/ls.txt";
char	in06fn_09[256]="./11c_110/_6/ls.txt";
char	in07fn_09[256]="./11c_110/_7/ls.txt";
char	in08fn_09[256]="./11c_110/_8/ls.txt";
char	in09fn_09[256]="./11c_110/_9/ls.txt";
char	in10fn_09[256]="./11c_110/_a10/ls.txt";
char	in11fn_09[256]="./11c_110/_a11/ls.txt";
char	in12fn_09[256]="./11c_110/_a12/ls.txt";
char	in13fn_09[256]="./11c_110/_a13/ls.txt";
char	in14fn_09[256]="./11c_110/_a14/ls.txt";
char	in15fn_09[256]="./11c_110/_a15/ls.txt";
char	in16fn_09[256]="./11c_110/_a16/ls.txt";
char	in17fn_09[256]="./11c_110/_a17/ls.txt";
char	in18fn_09[256]="./11c_110/_a18/ls.txt";
char	in19fn_09[256]="./11c_110/_a19/ls.txt";
/*
*/


char	na[70000][6];	int	nai=0;
char	ca[70000][6];	int	cai=0;
char	ta[6];		int	tai=0;

long	s1[70000][2];	int	sai=0;
char	s21[70000][256];
char	s22[70000][256];
int	s23[70000][2];
int	b1[nS*Sc];

int	p_3(char infn[256])
{

	char	fld[50][256];
	int	fi=0;
	int	fl[50];

	int	fbyte;
	int	i,j,k,l;

	int	c=0;

	f2=fopen(infn,"rb");

	fbyte=getc(f2);
	while(!feof(f2))
	{

		fi=0;for(i=0;i<50;++i){fl[i]=0;for(j=0;j<256;++j){fld[i][j]='\0';}}
		while(!feof(f2)&&fbyte!=13&&fbyte!=10){if(fbyte==9){++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f2);}
		while(!feof(f2)&&fbyte==13||fbyte==10){fbyte=getc(f2);}

		//printf(".%d.",fi);
		if(fi==5){++c;}
	}
	fclose(f2);

	return(c);
}

int	p_2(char infn[256],char	cs[6],int kd)
{

	char p_fn[256];

	char	fld[50][256];
	int	fi=0;
	int	fl[50];

	int	fbyte;
	int	i,j,k,l;
	int	a,b;
	int	cc[6][2];

	f1=fopen(infn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{

		fi=0;for(i=0;i<50;++i){fl[i]=0;for(j=0;j<256;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==9){++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}

		//printf(".%d.",fi);

		if(fi==0)
		{
			for(j=-1+strlen(fld[0]);j>=0;--j){if(fld[0][j]=='.'){break;}}
			for(i=0;i<j;++i){if(fld[0][i]>='A'&&fld[0][i]<='Z'||fld[0][i]=='_'){}else{break;}}
			if(i==j){}else{continue;}

			cc[0][0]=0;cc[1][0]=0;cc[2][0]=0;cc[3][0]=0;cc[4][0]=0;cc[5][0]=0;
			cc[0][1]=0;cc[1][1]=0;cc[2][1]=0;cc[3][1]=0;cc[4][1]=0;cc[5][1]=0;
			for(i=0;i<6;++i)
			{
				for(j=0;j<strlen(cs);++j)
				{
					if(fld[0][i]==cs[j]){++cc[j][0];cc[j][1]=1;break;}
				}
			}
			j=0;l=0;
			for(i=0;i<strlen(cs);++i){if(cc[i][0]!=0){if(cc[i][1]==1){++j;}l+=cc[i][0];}}

			for(i=0;i<256;++i){p_fn[i]='\0';}
			for(k=-1+strlen(infn);k>=0;--k){if(infn[k]=='/'){break;}}

			a=kd;b=0;
			for(i=-1+k;infn[i]!='_'&&infn[i]!='a';--i){if(infn[i]>='0'&&infn[i]<='9'){a+=(-48+infn[i])*pow(10,b);++b;}}

			for(i=0;i<=k;++i){p_fn[i]=infn[i];}++k;
			for(i=0;i<strlen(fld[0]);++i){p_fn[k]=fld[0][i];++k;}

			if(j==strlen(cs)&&l==6)
			{

				k=p_3(p_fn);//printf("%s %s %d\n",fld[0],infn,k);

				s1[sai][0]=((fld[0][0]-65)<<20)|
					((fld[0][1]-65)<<16)|
					((fld[0][2]-65)<<12)|
					((fld[0][3]-65)<<8)|
					((fld[0][4]-65)<<4)|
					((fld[0][5]-65)<<0);
				s1[sai][1]=sai;
				for(i=0;i<256;++i){s21[sai][i]='\0';}for(i=0;i<strlen(fld[0]);++i){s21[sai][i]=fld[0][i];}
				for(i=0;i<256;++i){s22[sai][i]='\0';}for(i=0;i<strlen(infn);++i){s22[sai][i]=infn[i];}
				s23[sai][0]=k;
				s23[sai][1]=a;
				++sai;
			}
		}
	}
	fclose(f1);

	return(0);
}

int	p_1(char infn[256])
{

	char p_fn[256];

	char	fld[50][256];
	int	fi=0;
	int	fl[50];

	int	fbyte;
	int	i,j,k,l;

	f1=fopen(infn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{

		fi=0;for(i=0;i<50;++i){fl[i]=0;for(j=0;j<256;++j){fld[i][j]='\0';}}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){if(fbyte==9){++fi;}else{fld[fi][fl[fi]]=fbyte;++fl[fi];}fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}

		//printf(".%d.",fi);

		if(fi==0)
		{
			for(j=-1+strlen(fld[0]);j>=0;--j){if(fld[0][j]=='.'){break;}}
			for(i=0;i<j;++i){if(fld[0][i]>='A'&&fld[0][i]<='Z'||fld[0][i]=='_'){}else{break;}}
			if(i==j){}else{continue;}

			for(i=0;i<256;++i){p_fn[i]='\0';}
			for(j=-1+strlen(infn);j>=0;--j){if(infn[j]=='/'){break;}}
			for(i=0;i<=j;++i){p_fn[i]=infn[i];}++j;
			for(i=0;i<strlen(fld[0]);++i){p_fn[j]=fld[0][i];++j;}

			//printf("%s\n",p_fn);

			for(i=0;i<nai;++i)
			{
				if
				(
					na[i][0]==fld[0][0]&&
					na[i][1]==fld[0][1]&&
					na[i][2]==fld[0][2]&&
					na[i][3]==fld[0][3]&&
					na[i][4]==fld[0][4]&&
					na[i][5]==fld[0][5]

				){break;}
			}
			if(i==nai)
			{
				na[nai][0]=fld[0][0];
				na[nai][1]=fld[0][1];
				na[nai][2]=fld[0][2];
				na[nai][3]=fld[0][3];
				na[nai][4]=fld[0][4];
				na[nai][5]=fld[0][5];
				++nai;				
			}

		}
	}
	fclose(f1);

	//printf("%d\n",nai);

	return(0);
}

int main()
{
	char	in_b_fn[255]="white_10x19.bmp";
	char	out_b_fn[255]="a.bmp";

	FILE    *bf1,*bf2;
	char	fbyte;
	int	ha[HLength];int	hai=0;

	int	i,j,k,l,m,n;
	int	a,b,c,d;

	char	r_1[6];
	long	t0,t1;

	strcpy(infn,in01fn);
	p_1(infn);
	strcpy(infn,in02fn);
	p_1(infn);
	strcpy(infn,in03fn);
	p_1(infn);
	strcpy(infn,in04fn);
	p_1(infn);
	strcpy(infn,in05fn);
	p_1(infn);
	strcpy(infn,in06fn);
	p_1(infn);
	strcpy(infn,in07fn);
	p_1(infn);
	strcpy(infn,in08fn);
	p_1(infn);
	strcpy(infn,in09fn);
	p_1(infn);
	strcpy(infn,in10fn);
	p_1(infn);
	strcpy(infn,in11fn);
	p_1(infn);
	strcpy(infn,in12fn);
	p_1(infn);
	strcpy(infn,in13fn);
	p_1(infn);
	strcpy(infn,in14fn);
	p_1(infn);
	strcpy(infn,in15fn);
	p_1(infn);
	strcpy(infn,in16fn);
	p_1(infn);
	strcpy(infn,in17fn);
	p_1(infn);
	strcpy(infn,in18fn);
	p_1(infn);
	strcpy(infn,in19fn);
	p_1(infn);


	strcpy(infn,in01fn_01);
	p_1(infn);
	strcpy(infn,in02fn_01);
	p_1(infn);
	strcpy(infn,in03fn_01);
	p_1(infn);
	strcpy(infn,in04fn_01);
	p_1(infn);
	strcpy(infn,in05fn_01);
	p_1(infn);
	strcpy(infn,in06fn_01);
	p_1(infn);
	strcpy(infn,in07fn_01);
	p_1(infn);
	strcpy(infn,in08fn_01);
	p_1(infn);
	strcpy(infn,in09fn_01);
	p_1(infn);
	strcpy(infn,in10fn_01);
	p_1(infn);
	strcpy(infn,in11fn_01);
	p_1(infn);
	strcpy(infn,in12fn_01);
	p_1(infn);
	strcpy(infn,in13fn_01);
	p_1(infn);
	strcpy(infn,in14fn_01);
	p_1(infn);
	strcpy(infn,in15fn_01);
	p_1(infn);
	strcpy(infn,in16fn_01);
	p_1(infn);
	strcpy(infn,in17fn_01);
	p_1(infn);
	strcpy(infn,in18fn_01);
	p_1(infn);
	strcpy(infn,in19fn_01);
	p_1(infn);

	strcpy(infn,in01fn_02);
	p_1(infn);
	strcpy(infn,in02fn_02);
	p_1(infn);
	strcpy(infn,in03fn_02);
	p_1(infn);
	strcpy(infn,in04fn_02);
	p_1(infn);
	strcpy(infn,in05fn_02);
	p_1(infn);
	strcpy(infn,in06fn_02);
	p_1(infn);
	strcpy(infn,in07fn_02);
	p_1(infn);
	strcpy(infn,in08fn_02);
	p_1(infn);
	strcpy(infn,in09fn_02);
	p_1(infn);
	strcpy(infn,in10fn_02);
	p_1(infn);
	strcpy(infn,in11fn_02);
	p_1(infn);
	strcpy(infn,in12fn_02);
	p_1(infn);
	strcpy(infn,in13fn_02);
	p_1(infn);
	strcpy(infn,in14fn_02);
	p_1(infn);
	strcpy(infn,in15fn_02);
	p_1(infn);
	strcpy(infn,in16fn_02);
	p_1(infn);
	strcpy(infn,in17fn_02);
	p_1(infn);
	strcpy(infn,in18fn_02);
	p_1(infn);
	strcpy(infn,in19fn_02);
	p_1(infn);


	strcpy(infn,in01fn_03);
	p_1(infn);
	strcpy(infn,in02fn_03);
	p_1(infn);
	strcpy(infn,in03fn_03);
	p_1(infn);
	strcpy(infn,in04fn_03);
	p_1(infn);
	strcpy(infn,in05fn_03);
	p_1(infn);
	strcpy(infn,in06fn_03);
	p_1(infn);
	strcpy(infn,in07fn_03);
	p_1(infn);
	strcpy(infn,in08fn_03);
	p_1(infn);
	strcpy(infn,in09fn_03);
	p_1(infn);
	strcpy(infn,in10fn_03);
	p_1(infn);
	strcpy(infn,in11fn_03);
	p_1(infn);
	strcpy(infn,in12fn_03);
	p_1(infn);
	strcpy(infn,in13fn_03);
	p_1(infn);
	strcpy(infn,in14fn_03);
	p_1(infn);
	strcpy(infn,in15fn_03);
	p_1(infn);
	strcpy(infn,in16fn_03);
	p_1(infn);
	strcpy(infn,in17fn_03);
	p_1(infn);
	strcpy(infn,in18fn_03);
	p_1(infn);
	strcpy(infn,in19fn_03);
	p_1(infn);

	strcpy(infn,in01fn_04);
	p_1(infn);
	strcpy(infn,in02fn_04);
	p_1(infn);
	strcpy(infn,in03fn_04);
	p_1(infn);
	strcpy(infn,in04fn_04);
	p_1(infn);
	strcpy(infn,in05fn_04);
	p_1(infn);
	strcpy(infn,in06fn_04);
	p_1(infn);
	strcpy(infn,in07fn_04);
	p_1(infn);
	strcpy(infn,in08fn_04);
	p_1(infn);
	strcpy(infn,in09fn_04);
	p_1(infn);
	strcpy(infn,in10fn_04);
	p_1(infn);
	strcpy(infn,in11fn_04);
	p_1(infn);
	strcpy(infn,in12fn_04);
	p_1(infn);
	strcpy(infn,in13fn_04);
	p_1(infn);
	strcpy(infn,in14fn_04);
	p_1(infn);
	strcpy(infn,in15fn_04);
	p_1(infn);
	strcpy(infn,in16fn_04);
	p_1(infn);
	strcpy(infn,in17fn_04);
	p_1(infn);
	strcpy(infn,in18fn_04);
	p_1(infn);
	strcpy(infn,in19fn_04);
	p_1(infn);

	strcpy(infn,in01fn_05);
	p_1(infn);
	strcpy(infn,in02fn_05);
	p_1(infn);
	strcpy(infn,in03fn_05);
	p_1(infn);
	strcpy(infn,in04fn_05);
	p_1(infn);
	strcpy(infn,in05fn_05);
	p_1(infn);
	strcpy(infn,in06fn_05);
	p_1(infn);
	strcpy(infn,in07fn_05);
	p_1(infn);
	strcpy(infn,in08fn_05);
	p_1(infn);
	strcpy(infn,in09fn_05);
	p_1(infn);
	strcpy(infn,in10fn_05);
	p_1(infn);
	strcpy(infn,in11fn_05);
	p_1(infn);
	strcpy(infn,in12fn_05);
	p_1(infn);
	strcpy(infn,in13fn_05);
	p_1(infn);
	strcpy(infn,in14fn_05);
	p_1(infn);
	strcpy(infn,in15fn_05);
	p_1(infn);
	strcpy(infn,in16fn_05);
	p_1(infn);
	strcpy(infn,in17fn_05);
	p_1(infn);
	strcpy(infn,in18fn_05);
	p_1(infn);
	strcpy(infn,in19fn_05);
	p_1(infn);

	strcpy(infn,in01fn_06);
	p_1(infn);
	strcpy(infn,in02fn_06);
	p_1(infn);
	strcpy(infn,in03fn_06);
	p_1(infn);
	strcpy(infn,in04fn_06);
	p_1(infn);
	strcpy(infn,in05fn_06);
	p_1(infn);
	strcpy(infn,in06fn_06);
	p_1(infn);
	strcpy(infn,in07fn_06);
	p_1(infn);
	strcpy(infn,in08fn_06);
	p_1(infn);
	strcpy(infn,in09fn_06);
	p_1(infn);
	strcpy(infn,in10fn_06);
	p_1(infn);
	strcpy(infn,in11fn_06);
	p_1(infn);
	strcpy(infn,in12fn_06);
	p_1(infn);
	strcpy(infn,in13fn_06);
	p_1(infn);
	strcpy(infn,in14fn_06);
	p_1(infn);
	strcpy(infn,in15fn_06);
	p_1(infn);
	strcpy(infn,in16fn_06);
	p_1(infn);
	strcpy(infn,in17fn_06);
	p_1(infn);
	strcpy(infn,in18fn_06);
	p_1(infn);
	strcpy(infn,in19fn_06);
	p_1(infn);

	strcpy(infn,in01fn_07);
	p_1(infn);
	strcpy(infn,in02fn_07);
	p_1(infn);
	strcpy(infn,in03fn_07);
	p_1(infn);
	strcpy(infn,in04fn_07);
	p_1(infn);
	strcpy(infn,in05fn_07);
	p_1(infn);
	strcpy(infn,in06fn_07);
	p_1(infn);
	strcpy(infn,in07fn_07);
	p_1(infn);
	strcpy(infn,in08fn_07);
	p_1(infn);
	strcpy(infn,in09fn_07);
	p_1(infn);
	strcpy(infn,in10fn_07);
	p_1(infn);
	strcpy(infn,in11fn_07);
	p_1(infn);
	strcpy(infn,in12fn_07);
	p_1(infn);
	strcpy(infn,in13fn_07);
	p_1(infn);
	strcpy(infn,in14fn_07);
	p_1(infn);
	strcpy(infn,in15fn_07);
	p_1(infn);
	strcpy(infn,in16fn_07);
	p_1(infn);
	strcpy(infn,in17fn_07);
	p_1(infn);
	strcpy(infn,in18fn_07);
	p_1(infn);
	strcpy(infn,in19fn_07);
	p_1(infn);

	strcpy(infn,in01fn_08);
	p_1(infn);
	strcpy(infn,in02fn_08);
	p_1(infn);
	strcpy(infn,in03fn_08);
	p_1(infn);
	strcpy(infn,in04fn_08);
	p_1(infn);
	strcpy(infn,in05fn_08);
	p_1(infn);
	strcpy(infn,in06fn_08);
	p_1(infn);
	strcpy(infn,in07fn_08);
	p_1(infn);
	strcpy(infn,in08fn_08);
	p_1(infn);
	strcpy(infn,in09fn_08);
	p_1(infn);
	strcpy(infn,in10fn_08);
	p_1(infn);
	strcpy(infn,in11fn_08);
	p_1(infn);
	strcpy(infn,in12fn_08);
	p_1(infn);
	strcpy(infn,in13fn_08);
	p_1(infn);
	strcpy(infn,in14fn_08);
	p_1(infn);
	strcpy(infn,in15fn_08);
	p_1(infn);
	strcpy(infn,in16fn_08);
	p_1(infn);
	strcpy(infn,in17fn_08);
	p_1(infn);
	strcpy(infn,in18fn_08);
	p_1(infn);
	strcpy(infn,in19fn_08);
	p_1(infn);

	strcpy(infn,in01fn_09);
	p_1(infn);
	strcpy(infn,in02fn_09);
	p_1(infn);
	strcpy(infn,in03fn_09);
	p_1(infn);
	strcpy(infn,in04fn_09);
	p_1(infn);
	strcpy(infn,in05fn_09);
	p_1(infn);
	strcpy(infn,in06fn_09);
	p_1(infn);
	strcpy(infn,in07fn_09);
	p_1(infn);
	strcpy(infn,in08fn_09);
	p_1(infn);
	strcpy(infn,in09fn_09);
	p_1(infn);
	strcpy(infn,in10fn_09);
	p_1(infn);
	strcpy(infn,in11fn_09);
	p_1(infn);
	strcpy(infn,in12fn_09);
	p_1(infn);
	strcpy(infn,in13fn_09);
	p_1(infn);
	strcpy(infn,in14fn_09);
	p_1(infn);
	strcpy(infn,in15fn_09);
	p_1(infn);
	strcpy(infn,in16fn_09);
	p_1(infn);
	strcpy(infn,in17fn_09);
	p_1(infn);
	strcpy(infn,in18fn_09);
	p_1(infn);
	strcpy(infn,in19fn_09);
	p_1(infn);
/*
*/



	for(i=0;i<nai;++i)
	{
		tai=0;
		for(j=0;j<6;++j)
		{
			if(j==0){ta[tai]=na[i][j];++tai;}else{
				for(k=0;k<tai;++k){if(ta[k]==na[i][j]){break;}}
				if(k==tai){ta[tai]=na[i][j];++tai;}
			}
		}
		for(l=0;l<cai;++l)
		{
			c=0;
			for(m=0;m<tai;++m)
			{
				for(n=0;n<6;++n)
				{
					if(ta[m]==ca[l][n]){++c;}
				}
			}				
			if(c==tai){break;}
		}		
		if(l==cai)
		{
			k=0;for(j=0;j<tai;++j){ca[cai][j]=ta[j];++k;}
			for(j=k;j<6;++j){ca[cai][j]='\0';}
			++cai;
		}
	}

	i=0;
        bf1=fopen(in_b_fn,"rb");
	bf2=fopen(out_b_fn,"wb");
	if(bf1==NULL){printf("No white.bmp!\n");return(0);}
	fbyte=getc(bf1);
	ha[hai]=(int)fbyte;++hai;
	while (!feof(bf1)&&hai<HLength){fbyte=getc(f1);ha[hai]=(int)fbyte;++hai;}fclose(bf1);
	for(i=0;i<HLength;++i){fprintf(bf2,"%c",ha[i]);}

	for(i=0;i<cai;++i)
	{
		printf("!%s ",ca[i]);

		strcpy(infn,in01fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in02fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in03fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in04fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in05fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in06fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in07fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in08fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in09fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in10fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in11fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in12fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in13fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in14fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in15fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in16fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in17fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in18fn);
		p_2(infn,ca[i],0*Sc);
		strcpy(infn,in19fn);
		p_2(infn,ca[i],0*Sc);

		strcpy(infn,in01fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in03fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in04fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in05fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in06fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in07fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in08fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in09fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in10fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in11fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in12fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in13fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in14fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in15fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in16fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in17fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in18fn_01);
		p_2(infn,ca[i],1*Sc);
		strcpy(infn,in19fn_01);
		p_2(infn,ca[i],1*Sc);

		strcpy(infn,in01fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in03fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in04fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in05fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in06fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in07fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in08fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in09fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in10fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in11fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in12fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in13fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in14fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in15fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in16fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in17fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in18fn_02);
		p_2(infn,ca[i],2*Sc);
		strcpy(infn,in19fn_02);
		p_2(infn,ca[i],2*Sc);

		strcpy(infn,in01fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in03fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in04fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in05fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in06fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in07fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in08fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in09fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in10fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in11fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in12fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in13fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in14fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in15fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in16fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in17fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in18fn_03);
		p_2(infn,ca[i],3*Sc);
		strcpy(infn,in19fn_03);
		p_2(infn,ca[i],3*Sc);


		strcpy(infn,in01fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in03fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in04fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in05fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in06fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in07fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in08fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in09fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in10fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in11fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in12fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in13fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in14fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in15fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in16fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in17fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in18fn_04);
		p_2(infn,ca[i],4*Sc);
		strcpy(infn,in19fn_04);
		p_2(infn,ca[i],4*Sc);


		strcpy(infn,in01fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in03fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in04fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in05fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in06fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in07fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in08fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in09fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in10fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in11fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in12fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in13fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in14fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in15fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in16fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in17fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in18fn_05);
		p_2(infn,ca[i],5*Sc);
		strcpy(infn,in19fn_05);
		p_2(infn,ca[i],5*Sc);


		strcpy(infn,in01fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in03fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in04fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in05fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in06fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in07fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in08fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in09fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in10fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in11fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in12fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in13fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in14fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in15fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in16fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in17fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in18fn_06);
		p_2(infn,ca[i],6*Sc);
		strcpy(infn,in19fn_06);
		p_2(infn,ca[i],6*Sc);


		strcpy(infn,in01fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in03fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in04fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in05fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in06fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in07fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in08fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in09fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in10fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in11fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in12fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in13fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in14fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in15fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in16fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in17fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in18fn_07);
		p_2(infn,ca[i],7*Sc);
		strcpy(infn,in19fn_07);
		p_2(infn,ca[i],7*Sc);

		strcpy(infn,in01fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in03fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in04fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in05fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in06fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in07fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in08fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in09fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in10fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in11fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in12fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in13fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in14fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in15fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in16fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in17fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in18fn_08);
		p_2(infn,ca[i],8*Sc);
		strcpy(infn,in19fn_08);
		p_2(infn,ca[i],8*Sc);


		strcpy(infn,in01fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in02fn_01);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in03fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in04fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in05fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in06fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in07fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in08fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in09fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in10fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in11fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in12fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in13fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in14fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in15fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in16fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in17fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in18fn_09);
		p_2(infn,ca[i],9*Sc);
		strcpy(infn,in19fn_09);
		p_2(infn,ca[i],9*Sc);
/*

*/


		printf("%d\n",sai);

		for(j=0;j<sai;++j)
		{
			for(k=0;k<sai;++k)
			{
				if(s1[j][0]<s1[k][0])
				{
					t0=s1[k][0];
					t1=s1[k][1];
					s1[k][0]=s1[j][0];
					s1[k][1]=s1[j][1];
					s1[j][0]=t0;
					s1[j][1]=t1;
				}
			}
		}		

		c=0;
		for(j=0;j<sai;++j)
		{
			if(j==0)
			{

				for(k=0;k<nS*Sc;++k){b1[k]=-1;}
				b1[-1+s23[s1[j][1]][1]]=s23[s1[j][1]][0];

				r_1[0]=s21[s1[j][1]][0];
				r_1[1]=s21[s1[j][1]][1];
				r_1[2]=s21[s1[j][1]][2];
				r_1[3]=s21[s1[j][1]][3];
				r_1[4]=s21[s1[j][1]][4];
				r_1[5]=s21[s1[j][1]][5];
				
				for(k=0;k<strlen(s21[s1[j][1]]);++k){printf("%c",s21[s1[j][1]][k]);}printf(" ");
				for(k=0;k<strlen(s22[s1[j][1]]);++k){printf("%c",s22[s1[j][1]][k]);}printf(" ");
				printf(" %d %d\n",s23[s1[j][1]][0],s23[s1[j][1]][1]);

			}else{
				if
				(
					r_1[0]==s21[s1[j][1]][0]&&
					r_1[1]==s21[s1[j][1]][1]&&
					r_1[2]==s21[s1[j][1]][2]&&
					r_1[3]==s21[s1[j][1]][3]&&
					r_1[4]==s21[s1[j][1]][4]&&
					r_1[5]==s21[s1[j][1]][5]
				)
				{
					b1[-1+s23[s1[j][1]][1]]=s23[s1[j][1]][0];	

					for(k=0;k<strlen(s21[s1[j][1]]);++k){printf("%c",s21[s1[j][1]][k]);}printf(" ");
					for(k=0;k<strlen(s22[s1[j][1]]);++k){printf("%c",s22[s1[j][1]][k]);}printf(" ");
					printf(" %d %d\n",s23[s1[j][1]][0],s23[s1[j][1]][1]);
				}else{

					++c;
					if(c<3000)
					{
						for(k=0;k<nS*Sc;++k)
						{
							if(b1[k]!=-1)
							{
								b1[k]*=1111;
								fprintf(bf2,"%c%c%c",(b1[k]&0x00ff0000)>>16,(b1[k]&0x0000ff00)>>8,b1[k]&0x000000ff);
								fprintf(bf2,"%c%c%c",(b1[k]&0x00ff0000)>>16,(b1[k]&0x0000ff00)>>8,b1[k]&0x000000ff);
								fprintf(bf2,"%c%c%c",(b1[k]&0x00ff0000)>>16,(b1[k]&0x0000ff00)>>8,b1[k]&0x000000ff);
								fprintf(bf2,"%c%c%c",(b1[k]&0x00ff0000)>>16,(b1[k]&0x0000ff00)>>8,b1[k]&0x000000ff);
							}else{
								fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
								fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
								fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
								fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
							}
						}
					}					

					for(k=0;k<nS*Sc;++k){b1[k]=-1;}
					b1[-1+s23[s1[j][1]][1]]=s23[s1[j][1]][0];

					printf("\n");
					for(k=0;k<strlen(s21[s1[j][1]]);++k){printf("%c",s21[s1[j][1]][k]);}printf(" ");
					for(k=0;k<strlen(s22[s1[j][1]]);++k){printf("%c",s22[s1[j][1]][k]);}printf(" ");
					printf(" %d %d\n",s23[s1[j][1]][0],s23[s1[j][1]][1]);

					r_1[0]=s21[s1[j][1]][0];
					r_1[1]=s21[s1[j][1]][1];
					r_1[2]=s21[s1[j][1]][2];
					r_1[3]=s21[s1[j][1]][3];
					r_1[4]=s21[s1[j][1]][4];
					r_1[5]=s21[s1[j][1]][5];

				}
			}
		}
		sai=0;
	}
	fclose(bf2);
/*
	for(j=c;j<3000;++j)
	{
		for(k=0;k<25;++k)
		{
			fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
			fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
			fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
			fprintf(bf2,"%c%c%c",((-1)&0x00ff0000)>>16,((-1)&0x0000ff00)>>8,(-1)&0x000000ff);
		}
	}
*/
	return(0);

}
