//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko December,2005
//
//			to Maria Dzinleska


#include <stdio.h>
#include <string.h>
#include <math.h>

char 	in1fn[255]="a13_all.txt";
char 	in2fn[255]="_000-025.txt";
char 	in3fn[255]="a.bat";

char	fn1[255]="_000-025.txt";
char	fn2[255]="_026-050.txt";
char	fn3[255]="_051-075.txt";
char	fn4[255]="_076-100.txt";
char	fn5[255]="_101-125.txt";
char	fn6[255]="_126-150.txt";
char	fn7[255]="_151-175.txt";
char	fn8[255]="_176-200.txt";
char	fn9[255]="_201-225.txt";
char	fn10[255]="_226-250.txt";
char	fn11[255]="_251-275.txt";
char	fn12[255]="_276-300.txt";
char	fn13[255]="_301-325.txt";
char	fn14[255]="_326-350.txt";
char	fn15[255]="_351-375.txt";
char	fn16[255]="_376-400.txt";
char	fn17[255]="_401-425.txt";
char	fn18[255]="_426-450.txt";
char	fn19[255]="_451-475.txt";
char	fn20[255]="_476-500.txt";
char	fn21[255]="_501-525.txt";
char	fn22[255]="_526-550.txt";
//char	fn23[255]="_551-575.txt";
//char	fn24[255]="_576-600.txt";
//char	fn25[255]="_601-625.txt";

FILE	*f1,*f2,*f3;

char	ca[6][4];
int	ci[6];
int	cr[6];

int	crl[6][2];

char	frs[27][19000][256];
int	fcsi[27];
int	frsi=0;

char	fbyte;

char	fr[1024];
int	fri=0;

int main(int argc,char *argv[])
{

	char 	p1[20];
	char 	p2[20];

	int	i,j,k,l,m;

	int	a;
	long	pos;

	if(argv[1]!=NULL){strcpy(p1,argv[1]);}
	if(argv[2]!=NULL){strcpy(p2,argv[2]);}

	for(i=1;i<=25;++i)
	{
		if(i==1){for(j=0;j<strlen(fn1);++j){in2fn[j]=fn1[j];}}
		if(i==2){for(j=0;j<strlen(fn2);++j){in2fn[j]=fn2[j];}}
		if(i==3){for(j=0;j<strlen(fn3);++j){in2fn[j]=fn3[j];}}
		if(i==4){for(j=0;j<strlen(fn4);++j){in2fn[j]=fn4[j];}}
		if(i==5){for(j=0;j<strlen(fn5);++j){in2fn[j]=fn5[j];}}	
		if(i==6){for(j=0;j<strlen(fn6);++j){in2fn[j]=fn6[j];}}
		if(i==7){for(j=0;j<strlen(fn7);++j){in2fn[j]=fn7[j];}}
		if(i==8){for(j=0;j<strlen(fn8);++j){in2fn[j]=fn8[j];}}
		if(i==9){for(j=0;j<strlen(fn9);++j){in2fn[j]=fn9[j];}}
		if(i==10){for(j=0;j<strlen(fn10);++j){in2fn[j]=fn10[j];}}
		if(i==11){for(j=0;j<strlen(fn11);++j){in2fn[j]=fn11[j];}}
		if(i==12){for(j=0;j<strlen(fn12);++j){in2fn[j]=fn12[j];}}
		if(i==13){for(j=0;j<strlen(fn13);++j){in2fn[j]=fn13[j];}}
		if(i==14){for(j=0;j<strlen(fn14);++j){in2fn[j]=fn14[j];}}
		if(i==15){for(j=0;j<strlen(fn15);++j){in2fn[j]=fn15[j];}}
		if(i==16){for(j=0;j<strlen(fn16);++j){in2fn[j]=fn16[j];}}
		if(i==17){for(j=0;j<strlen(fn17);++j){in2fn[j]=fn17[j];}}
		if(i==18){for(j=0;j<strlen(fn18);++j){in2fn[j]=fn18[j];}}
		if(i==19){for(j=0;j<strlen(fn19);++j){in2fn[j]=fn19[j];}}
		if(i==20){for(j=0;j<strlen(fn20);++j){in2fn[j]=fn20[j];}}
		if(i==21){for(j=0;j<strlen(fn21);++j){in2fn[j]=fn21[j];}}
		if(i==22){for(j=0;j<strlen(fn22);++j){in2fn[j]=fn22[j];}}
		//if(i==23){for(j=0;j<strlen(fn23);++j){in2fn[j]=fn23[j];}}
		//if(i==24){for(j=0;j<strlen(fn24);++j){in2fn[j]=fn24[j];}}
		//if(i==25){for(j=0;j<strlen(fn25);++j){in2fn[j]=fn25[j];}}


		fcsi[i]=0;for(j=0;j<256;++j){frs[i][fcsi[i]][j]='\0';}frsi=0;

		f2=fopen(in2fn,"rb");

		fbyte=getc(f2);
		a=0;
		while(!feof(f2))
		{
			frs[i][fcsi[i]][frsi]=fbyte;++frsi;

			if(fbyte==' ')
			{
				++a;
				if(a==1){pos=ftell(f2);}
				if(a==6&&frsi!=30){frsi=0;a=0;fseek(f2,pos,SEEK_SET);}
				if(a==6&&frsi==30)
				{
					++fcsi[i];	
					for(j=0;j<256;++j){frs[i][fcsi[i]][j]='\0';}frsi=0;
					a=0;
					fseek(f2,pos,SEEK_SET);
				}
			}
			fbyte=getc(f2);	
		}
		fclose(f2);//printf(" %d ",fcsi[i]);
	}

	for(i=0;i<1024;++i){fr[i]='\0';}fri=0;

	f3=fopen(in3fn,"rb");
	fbyte=getc(f3);

	while(!feof(f3))
	{

		while(fbyte!=10&&fbyte!=13&&!feof(f3)){fr[fri]=fbyte;++fri;fbyte=getc(f3);}
		while(fbyte==10||fbyte==13&&!feof(f3)){fbyte=getc(f3);}

		for(i=0;fr[i]!='"'&&i<fri;++i){}
		l=0;for(j=i+1;fr[j]!='"'&&j<fri;++j){p1[l]=fr[j];++l;}
		for(i=j+1;fr[i]!='"';++i){}
		l=0;for(j=i+1;fr[j]!='"'&&j<fri;++j){p2[l]=fr[j];++l;}

		//printf("%s\n",p1);
		//printf("%s\n",p2);

		ci[0]=-48+p1[0]; 
		ci[1]=-48+p1[2];	
		ci[2]=-48+p1[4];	
		ci[3]=-48+p1[6];	
		ci[4]=-48+p1[8];	
		ci[5]=-48+p1[10];

		ca[0][0]='A';ca[0][1]='A';ca[0][2]='A';ca[0][3]='A';
		ca[1][0]='A';ca[1][1]='A';ca[1][2]='A';ca[1][3]='A';
		ca[2][0]='A';ca[2][1]='A';ca[2][2]='A';ca[2][3]='A';
		ca[3][0]='A';ca[3][1]='A';ca[3][2]='A';ca[3][3]='A';
		ca[4][0]='A';ca[4][1]='A';ca[4][2]='A';ca[4][3]='A';
		ca[5][0]='A';ca[5][1]='A';ca[5][2]='A';ca[5][3]='A';

		ca[0][ci[0]]=p2[0];
		ca[1][ci[1]]=p2[2];
		ca[2][ci[2]]=p2[4];
		ca[3][ci[3]]=p2[6];
		ca[4][ci[4]]=p2[8];
		ca[5][ci[5]]=p2[10];

		printf("%d %d %d %d %d %d\n",ci[0],ci[1],ci[2],ci[3],ci[4],ci[5]);	

		for(a=1;a<=22;++a)
		{
			for(j=0;j<fcsi[a];++j)
			{
				k=5;
				while(k<=30)
				{
					if(k/5==1){if(ca[0][ci[0]]==frs[a][j][k-5+ci[0]]){for(l=-1+k-5+ci[0];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					if(k/5==2){if(ca[1][ci[1]]==frs[a][j][k-5+ci[1]]){for(l=-1+k-5+ci[1];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					if(k/5==3){if(ca[2][ci[2]]==frs[a][j][k-5+ci[2]]){for(l=-1+k-5+ci[2];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					if(k/5==4){if(ca[3][ci[3]]==frs[a][j][k-5+ci[3]]){for(l=-1+k-5+ci[3];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					if(k/5==5){if(ca[4][ci[4]]==frs[a][j][k-5+ci[4]]){for(l=-1+k-5+ci[4];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					if(k/5==6){if(ca[5][ci[5]]==frs[a][j][k-5+ci[5]]){for(l=-1+k-5+ci[5];l>k-5;--l){if(frs[a][j][l]=='A'){}else{break;}}if(l==k-5){}else{break;}}else{break;}}
					k+=5;
				}
				if(k==35)
				{
					if(a==1 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn1);}
					if(a==2 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn2);}
					if(a==3 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn3);}
					if(a==4 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn4);}
					if(a==5 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn5);}
					if(a==6 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn6);}
					if(a==7 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn7);}
					if(a==8 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn8);}
					if(a==9 ){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn9);}
					if(a==10){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn10);}
					if(a==11){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn11);}
					if(a==12){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn12);}
					if(a==13){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn13);}
					if(a==14){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn14);}
					if(a==15){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn15);}
					if(a==16){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn16);}
					if(a==17){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn17);}
					if(a==18){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn18);}
					if(a==19){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn19);}
					if(a==20){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn20);}
					if(a==21){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn21);}
					if(a==22){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn22);}
					//if(a==23){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn23);}
					//if(a==24){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn24);}
					//if(a==25){printf("!6:1,1,1,1,1,1 %s %s\n",frs[a][j],fn25);}
				}
			}
		}

		for(i=0;i<1024;++i){fr[i]='\0';}fri=0;
	}
	fclose(f3);

	return(0);
}	